#ifndef globjectH
#define globjectH

#include "glincludes.h"

namespace GL
{

class NullBase // empty class as a default base for the GLObject
{ };

template <class ObjectOps, class ObjectBase = NullBase>
class Object : public virtual ObjectBase
{
public:
	Object() : ID(ObjectOps::GenerateID())
	{
		Bind();	
	}
	virtual ~Object()
	{
		ObjectOps::Destroy(ID);
	}

	void Bind() const
	{
		ObjectOps::Bind(ID);
	}

	unsigned int GetID() const { return ID; }
protected:
	GLuint ID;
};

}

#endif